/*
	Выживаемость - позволяет остаться в живых с 1 хп, получив смертельное ранение...
	Впишите в addons/sourcemod/translations/vip_modules.phrases.txt следующее:
	
	"Survivability"
	{
		"ru"		"Выживаемость"
		"en"		"Survivability"
	}
	
	И в groups.ini:
	
	"Survivability"		"75" // Шанс того что выживаемость все же будет использована > от 1% до 100% | 0 - выключить
*/

#include <sdkhooks>
#include <vip_core>

public Plugin myinfo =
{
	name = "(VIP) Survivability | Выживаемость",
	author = "Drumanid", 
	version = "1.1.0",
	url = "Discord: Drumanid#9108"
}

static const char g_sFeature[] = "Survivability";
bool g_bUse[MAXPLAYERS +1], g_bFade, g_bGame, g_bType;
char g_sWeapon[512];
int g_iFeature[MAXPLAYERS +1];

public APLRes AskPluginLoad2(Handle hMySelf, bool bLate, char[] szError, int iErrMax)
{
	if(GetEngineVersion() == Engine_CSGO) g_bGame = true;
	else g_bGame = false;
	
	return APLRes_Success;
}

public void OnPluginStart()
{
	ConVar hCv;
	(hCv = CreateConVar("VS_WEAPON", "awp|knife|decoy", "Список оружия от которого можно получить урон и вас не спасет 'выживаемость'")).AddChangeHook(Cvar_Weapon);
	hCv.GetString(g_sWeapon, sizeof(g_sWeapon));
	(hCv = CreateConVar("VS_FADE", "1", "1 - включить | 0 - выключить эффект ", _, true, 0.0, true, 1.0)).AddChangeHook(Cvar_Fade);
	g_bFade = hCv.BoolValue;
	
	HookEvent("player_connect_full", PlayerConnectFull);
	HookEvent("player_spawn", PlayerSpawn);
	
	LoadTranslations("vip_modules.phrases");
	if(VIP_IsVIPLoaded()) VIP_OnVIPLoaded();
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i) && !IsFakeClient(i) && g_iFeature[i] != 0)
		{
			SDKHook(i, SDKHook_OnTakeDamage, OnTakeDamage);
			g_bUse[i] = false;
		}
	}
	
	AutoExecConfig(true, "VIP_Survivability", "vip");
}

public void Cvar_Weapon(ConVar hCv, const char[] sOldValue, const char[] sNewValue)
{
	hCv.GetString(g_sWeapon, sizeof(g_sWeapon));
}

public void Cvar_Fade(ConVar hCv, const char[] sOldValue, const char[] sNewValue)
{
	g_bFade = hCv.BoolValue;
}

public void OnConfigsExecuted()
{
	g_bType = GetConVarBool(FindConVar("mp_friendlyfire"));
}

public void OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, INT, _, _, OnDisplayItem);
}

public void VIP_OnVIPClientLoaded(int iClient)
{
	g_iFeature[iClient] = VIP_GetClientFeatureInt(iClient, g_sFeature);
}

public bool OnDisplayItem(int iClient, const char[] sFeature, char[] sDisplay, int iMaxlen)
{
	if(VIP_IsClientFeatureUse(iClient, g_sFeature))
	{
		SetGlobalTransTarget(iClient);
		FormatEx(sDisplay, iMaxlen, "%t [%i%%]", sFeature, g_iFeature[iClient]);
		return true;
	}

	return false;
}

public void PlayerConnectFull(Event hEvent, const char[] sName, bool bDbc)
{
	CreateTimer(0.0, TimerCheckVip, hEvent.GetInt("userid"));
}

public Action TimerCheckVip(Handle hTimer, any iClient)
{
	iClient = GetClientOfUserId(iClient);
	if(!IsFakeClient(iClient) && g_iFeature[iClient] != 0) SDKHook(iClient, SDKHook_OnTakeDamage, OnTakeDamage);
	
	return Plugin_Stop;
}

public void PlayerSpawn(Event hEvent, const char[] sName, bool bDbc)
{
	g_bUse[GetClientOfUserId(hEvent.GetInt("userid"))] = false;
}

public Action OnTakeDamage(int iVictim, int &iAttacker, int &iInflictor, float &fDamage, int &iDamageType)
{
	if(IsValidClient(iAttacker) && IsValidClient(iVictim) && VIP_IsClientFeatureUse(iVictim, g_sFeature) &&
	(g_bType && iAttacker != iVictim) || (!g_bType && GetClientTeam(iAttacker) != GetClientTeam(iVictim)) &&
	!g_bUse[iVictim] && (GetClientHealth(iVictim) - RoundToCeil(fDamage)) <= 0 && (GetRandomInt(1, 100) <= g_iFeature[iVictim]))
	{
		int iWeapon;
		if((iWeapon = GetEntPropEnt(iAttacker, Prop_Data, "m_hActiveWeapon")) != -1 && IsValidEntity(iWeapon))
		{
			char sWeapon[32];
			GetWeaponName(iWeapon, sWeapon, sizeof(sWeapon));
			
			if(g_sWeapon[0] == 0 || !(StrContains(g_sWeapon, sWeapon[FindCharInString(sWeapon, '_') +1], false) != -1))
			{
				if(g_bFade)
				{
					Handle hMessage = StartMessageOne("Fade", iVictim);
					if(g_bGame)
					{
						PbSetInt(hMessage, "duration", 150);
						PbSetInt(hMessage, "hold_time", 1);
						PbSetInt(hMessage, "flags", 0x0001);
						PbSetColor(hMessage, "clr", {255, 0, 0, 100});
					}
					else
					{
						BfWriteShort(hMessage, 150);
						BfWriteShort(hMessage, 1);
						BfWriteShort(hMessage, 0x0001);
						BfWriteByte(hMessage, 255);
						BfWriteByte(hMessage, 0);
						BfWriteByte(hMessage, 0);
						BfWriteByte(hMessage, 100);
					}
					EndMessage();
				}

				PrintToChat(iAttacker, "TEST");
				SetEntityHealth(iVictim, 1);
				g_bUse[iVictim] = true;
			
				return Plugin_Handled;
			}
		}
	}
	
	return Plugin_Continue;
}

void GetWeaponName(int iWeapon, char[] sBuffer, int iSize)
{
	switch(GetEntProp(iWeapon, Prop_Send, "m_iItemDefinitionIndex"))
	{
		case 1: strcopy(sBuffer, iSize, "weapon_deagle");
		case 3: strcopy(sBuffer, iSize, "weapon_fiveseven");
		case 16: strcopy(sBuffer, iSize, "weapon_m4a1");
		case 23: strcopy(sBuffer, iSize, "weapon_mp5sd");
		case 32: strcopy(sBuffer, iSize, "weapon_hkp2000");
		case 33: strcopy(sBuffer, iSize, "weapon_mp7");
		case 60: strcopy(sBuffer, iSize, "weapon_m4a1_silencer");
		case 61: strcopy(sBuffer, iSize, "weapon_usp_silencer");
		case 63: strcopy(sBuffer, iSize, "weapon_cz75a");
		case 64: strcopy(sBuffer, iSize, "weapon_revolver");
		default: GetEdictClassname(iWeapon, sBuffer, iSize);
	}
}

bool IsValidClient(int iClient)
{
	if(1 <= iClient <= MaxClients && IsClientInGame(iClient)) return true;   
	return false; 
}